Index: /profileconnection/src/main/java/geniusweb/profileconnection/ProfileInterface.java
===================================================================
--- /profileconnection/src/main/java/geniusweb/profileconnection/ProfileInterface.java	(revision 9)
+++ /profileconnection/src/main/java/geniusweb/profileconnection/ProfileInterface.java	(revision 10)
@@ -1,3 +1,5 @@
 package geniusweb.profileconnection;
+
+import java.io.IOException;
 
 import geniusweb.profile.Profile;
@@ -12,7 +14,6 @@
 	 * @return the latest version of the profile. May change at any time, after
 	 *         someone updates the version on the server. Call to this may block
-	 *         for limited time if the profile is not yet available. May return
-	 *         null if the profile is not available.
-	 */
-	public Profile getProfile();
+	 *         for limited time if the profile is not yet available. 
+	 *         @throws IOException if profile can not be fetched	 */
+	public Profile getProfile() throws IOException;
 }
Index: /profileconnection/src/main/java/geniusweb/profileconnection/WebsocketProfileConnector.java
===================================================================
--- /profileconnection/src/main/java/geniusweb/profileconnection/WebsocketProfileConnector.java	(revision 9)
+++ /profileconnection/src/main/java/geniusweb/profileconnection/WebsocketProfileConnector.java	(revision 10)
@@ -69,5 +69,5 @@
 
 	@Override
-	public Profile getProfile() {
+	public Profile getProfile() throws IOException {
 		int remaining_wait = TIMEOUT_MS;
 		try {
@@ -80,4 +80,7 @@
 					e);
 		}
+		if (profile == null) {
+			throw new IOException("Failed to fetch profile");
+		}
 		return profile;
 	}
Index: /profileconnection/src/test/java/geniusweb/profileconnection/WebsocketProfileConnectorTest.java
===================================================================
--- /profileconnection/src/test/java/geniusweb/profileconnection/WebsocketProfileConnectorTest.java	(revision 9)
+++ /profileconnection/src/test/java/geniusweb/profileconnection/WebsocketProfileConnectorTest.java	(revision 10)
@@ -3,5 +3,4 @@
 import static org.junit.Assert.assertEquals;
 import static org.junit.Assert.assertNotNull;
-import static org.junit.Assert.assertNull;
 import static org.mockito.Matchers.any;
 import static org.mockito.Mockito.mock;
@@ -22,5 +21,4 @@
 
 import geniusweb.profile.Profile;
-import geniusweb.profileconnection.WebsocketProfileConnector;
 import tudelft.utilities.logging.Reporter;
 
@@ -42,10 +40,9 @@
 
 	@Test
-	public void testOnOpen()
+	public void onOpenSmokeTest()
 			throws IOException, DeploymentException, URISyntaxException {
 		WebsocketProfileConnector connector = new WebsocketProfileConnector(
 				new URI("ws://someprofile"), reporter, wscontainer);
 		connector.onOpen(session);
-		assertNull(connector.getProfile());
 	}
 
@@ -93,5 +90,5 @@
 	}
 
-	@Test
+	@Test(expected = IOException.class)
 	public void testGetProfileTimeout()
 			throws DeploymentException, IOException, URISyntaxException {
@@ -116,6 +113,5 @@
 			}
 		}).start();
-		Profile profile = connector.getProfile();
-		assertNull(profile);
+		connector.getProfile();
 	}
 
Index: /protocol/src/main/java/geniusweb/protocol/session/DefaultSessionState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/DefaultSessionState.java	(revision 9)
+++ /protocol/src/main/java/geniusweb/protocol/session/DefaultSessionState.java	(revision 10)
@@ -64,9 +64,9 @@
 			Map<PartyId, PartyWithProfile> partyprofiles, ProtocolException e) {
 		if (partyprofiles == null) {
-			partyprofiles = Collections.EMPTY_MAP;
+			partyprofiles = Collections.emptyMap();
 		}
 		if (conns == null) {
 			this.connections = new ProtocolToPartyConnections(
-					Collections.EMPTY_LIST);
+					Collections.emptyList());
 		} else {
 			this.connections = conns;
@@ -97,5 +97,4 @@
 
 	/**
-	 * @return
 	 * @return map with {@link PartyWithProfile} for the parties. May be an
 	 *         incomplete map, as more parties with their profiles may be set
Index: /protocol/src/main/java/geniusweb/protocol/session/SessionSettings.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/SessionSettings.java	(revision 9)
+++ /protocol/src/main/java/geniusweb/protocol/session/SessionSettings.java	(revision 10)
@@ -7,4 +7,5 @@
 import geniusweb.protocol.NegoSettings;
 import geniusweb.protocol.session.saop.SAOPSettings;
+import geniusweb.protocol.session.shaop.SHAOPSettings;
 import geniusweb.references.PartyWithProfile;
 import tudelft.utilities.logging.Reporter;
@@ -13,6 +14,6 @@
  * interface for settings for session protocols. Immutable.
  */
-@JsonSubTypes({ @JsonSubTypes.Type(value = SAOPSettings.class) })
-
+@JsonSubTypes({ @JsonSubTypes.Type(value = SAOPSettings.class),
+		@JsonSubTypes.Type(value = SHAOPSettings.class) })
 public interface SessionSettings extends NegoSettings {
 
@@ -22,22 +23,31 @@
 	 * @return list of {@link PartyWithProfile} items.
 	 */
-	public List<PartyWithProfile> getParticipants();
+	List<TeamOfPartiesAndProfiles> getTeams();
 
 	/**
-	 * Allows modification of SessionSettings to include a party. This is needed for
-	 * tournament auto-configuration of sessions.
+	 * Allows modification of SessionSettings to include a party. This is needed
+	 * for tournament auto-configuration of sessions.
 	 * 
-	 * @param partyprof the party with profile to be added
+	 * @param partyprofteam the {@link TeamOfPartiesAndProfiles} to be added
 	 * @return new modified SessionSettings object
 	 */
-	public SessionSettings with(PartyWithProfile partyprof);
+	SessionSettings with(TeamOfPartiesAndProfiles partyprofteam);
+
+	/**
+	 * 
+	 * @return all parties from all teams, as a flattened ordered list. The
+	 *         order : start with all parties from team 1, then all from team 2,
+	 *         etc. The specific order of the parties from a team depends on the
+	 *         protocol.
+	 */
+	List<PartyWithProfile> getAllParties();
 
 	/**
 	 * @param logger the logger where the protocol can log events to.
-	 * @return the an initialized and ready to use {@link SessionProtocol} that can
-	 *         handle this Negotiation.
+	 * @return the an initialized and ready to use {@link SessionProtocol} that
+	 *         can handle this Negotiation.
 	 */
 	@Override
-	public SessionProtocol getProtocol(Reporter logger);
+	SessionProtocol getProtocol(Reporter logger);
 
 }
Index: /protocol/src/main/java/geniusweb/protocol/session/TeamOfPartiesAndProfiles.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/TeamOfPartiesAndProfiles.java	(revision 10)
+++ /protocol/src/main/java/geniusweb/protocol/session/TeamOfPartiesAndProfiles.java	(revision 10)
@@ -0,0 +1,34 @@
+package geniusweb.protocol.session;
+
+import java.util.List;
+
+import com.fasterxml.jackson.annotation.JsonAutoDetect;
+import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
+import com.fasterxml.jackson.annotation.JsonSubTypes;
+
+import geniusweb.protocol.session.saop.SaopPartyWithProfile;
+import geniusweb.protocol.session.shaop.ShaopTeam;
+import geniusweb.references.PartyWithProfile;
+
+/**
+ * Contains a functional team, eg in SHAOP a team would be a SHAOP together with
+ * his COB partner. In SAOP this is just a SAOP party.
+ * 
+ * This is needed to specify the general SessionSettings functionality in a
+ * sufficient general way
+ *
+ */
+@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE)
+// we do not use JsonTypeInfo because we always use a specific Team within a protocol
+// and do not (de)serialize individual TeamOfPartiesAndProfiles.
+//@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.WRAPPER_OBJECT)
+@JsonSubTypes({ @JsonSubTypes.Type(value = SaopPartyWithProfile.class),
+		@JsonSubTypes.Type(value = ShaopTeam.class) })
+public interface TeamOfPartiesAndProfiles {
+	/**
+	 * 
+	 * @return the list of all parties involved, which is the parties in all
+	 *         teams combined.
+	 */
+	List<PartyWithProfile> getAllParties();
+}
Index: /protocol/src/main/java/geniusweb/protocol/session/saop/SAOP.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/saop/SAOP.java	(revision 9)
+++ /protocol/src/main/java/geniusweb/protocol/session/saop/SAOP.java	(revision 10)
@@ -65,8 +65,8 @@
 public class SAOP extends DefaultListenable<ProtocolEvent>
 		implements SessionProtocol {
-	private static final int TIME_MARGIN = 20;// ms extra delay after deadline
-	private static final int MINDURATION = 100;
-	private static final int MIN_SLEEP_TIME = 1000;
-	private static final int MAX_SLEEP_TIME = 60000;
+	public static final int TIME_MARGIN = 20;// ms extra delay after deadline
+	public static final int MINDURATION = 100;
+	public static final int MIN_SLEEP_TIME = 1000;
+	public static final int MAX_SLEEP_TIME = 60000;
 	private static final ProtocolRef SAOP = new ProtocolRef("SAOP");
 	private final Reporter log;
@@ -154,5 +154,5 @@
 			throws InterruptedException, IOException {
 		List<PartyWithProfile> participants = state.getSettings()
-				.getParticipants();
+				.getAllParties();
 		List<Reference> parties = participants.stream()
 				.map(parti -> (parti.getParty().getPartyRef()))
@@ -319,4 +319,6 @@
 			setState(state.with(new ProtocolException(message, party, e)));
 		}
+		log.log(Level.WARNING, "SAOP protocol intercepted error due to party "
+				+ party + ":" + message, e);
 	}
 
Index: /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPSettings.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPSettings.java	(revision 9)
+++ /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPSettings.java	(revision 10)
@@ -4,4 +4,5 @@
 import java.util.LinkedList;
 import java.util.List;
+import java.util.stream.Collectors;
 
 import com.fasterxml.jackson.annotation.JsonCreator;
@@ -11,9 +12,10 @@
 import geniusweb.protocol.session.SessionProtocol;
 import geniusweb.protocol.session.SessionSettings;
+import geniusweb.protocol.session.TeamOfPartiesAndProfiles;
 import geniusweb.references.PartyWithProfile;
 import tudelft.utilities.logging.Reporter;
 
 public class SAOPSettings implements SessionSettings {
-	private final List<PartyWithProfile> participants;
+	private final List<SaopPartyWithProfile> participants;
 	private final Deadline deadline;
 
@@ -28,5 +30,5 @@
 	@JsonCreator
 	public SAOPSettings(
-			@JsonProperty("participants") List<PartyWithProfile> participants,
+			@JsonProperty("participants") List<SaopPartyWithProfile> participants,
 			@JsonProperty("deadline") Deadline deadline) {
 		this.participants = participants;
@@ -51,5 +53,5 @@
 
 	@Override
-	public List<PartyWithProfile> getParticipants() {
+	public List<TeamOfPartiesAndProfiles> getTeams() {
 		return Collections.unmodifiableList(participants);
 	}
@@ -60,4 +62,11 @@
 	public Deadline getDeadline() {
 		return deadline;
+	}
+
+	@Override
+	public List<PartyWithProfile> getAllParties() {
+		return participants.stream()
+				.map(particip -> particip.getAllParties().get(0))
+				.collect(Collectors.toList());
 	}
 
@@ -101,7 +110,11 @@
 
 	@Override
-	public SessionSettings with(PartyWithProfile party) {
-		List<PartyWithProfile> newparts = new LinkedList<>(participants);
-		newparts.add(party);
+	public SessionSettings with(TeamOfPartiesAndProfiles party) {
+		if (!(party instanceof SaopPartyWithProfile))
+			throw new IllegalArgumentException(
+					"Added party must be SaopPartyWithProfile but got "
+							+ party);
+		List<SaopPartyWithProfile> newparts = new LinkedList<>(participants);
+		newparts.add((SaopPartyWithProfile) party);
 		return new SAOPSettings(newparts, deadline);
 	}
Index: /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java	(revision 9)
+++ /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java	(revision 10)
@@ -16,6 +16,6 @@
 import geniusweb.progress.ProgressRounds;
 import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
 import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
-import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
 import geniusweb.protocol.session.DefaultSessionState;
 import geniusweb.protocol.session.SessionSettings;
@@ -61,24 +61,4 @@
 
 	/**
-	 * @param actor         the actor that did this action. Can be used to check
-	 *                      if action is valid. NOTICE caller has to make sure
-	 *                      the current state is not final.
-	 * @param action        the action that was proposed by actor.
-	 * @param currentTimeMs the current time in ms since 1970, see
-	 *                      {@link System#currentTimeMillis()}
-	 * @return new SessionState with the action added as last action.
-	 */
-	public SAOPState with(PartyId actor, Action action) {
-		try {
-			return with1(actor, action);
-		} catch (ProtocolException e) {
-			List<Action> newactions = new LinkedList<>(getActions());
-			newactions.add(action);
-			return new SAOPState(newactions, getConnections(), getProgress(),
-					getSettings(), getPartyProfiles(), e);
-		}
-	}
-
-	/**
 	 * 
 	 * @param connection   the new {@link ProtocolToPartyConn}
@@ -164,4 +144,59 @@
 
 	/**
+	 * @param actor         the actor that did this action. Can be used to check
+	 *                      if action is valid. NOTICE caller has to make sure
+	 *                      the current state is not final.
+	 * @param action        the action that was proposed by actor.
+	 * @param currentTimeMs the current time in ms since 1970, see
+	 *                      {@link System#currentTimeMillis()}
+	 * @return new SessionState with the action added as last action.
+	 */
+
+	public SAOPState with(PartyId actor, Action action) {
+
+		if (actor == null) { // this is a bug
+			throw new IllegalArgumentException("actor must not be null");
+		}
+		if (!actor.equals(getNextActor())) {
+			throw new IllegalArgumentException("Party does not have the turn ");
+
+		}
+		if (action == null) {
+			throw new IllegalArgumentException("action is null");
+		}
+		if (!actor.equals(action.getActor())) {
+			throw new IllegalArgumentException(
+					"act contains wrong credentials: " + action);
+		}
+
+		// check protocol is followed for specific actions
+		if (action instanceof Accept) {
+			Bid bid = getLastBid();
+			if (bid == null) {
+				throw new IllegalArgumentException(
+						"Accept without a recent offer");
+			}
+			if (!bid.equals(((Accept) action).getBid())) {
+				throw new IllegalArgumentException(
+						"Party accepts a bid differing from the last offer ="
+								+ bid + ", action=" + action + ")");
+			}
+		} else if (action instanceof Offer) {
+			// offer is always fine. We don't check if bid is actually in domain
+			// or complete etc. We would need domain for that
+		} else if (action instanceof EndNegotiation) {
+			// just act, we will get into the final state then.
+		} else {
+			throw new IllegalArgumentException(
+					"Action " + action + " is not allowed in SAOP");
+		}
+
+		List<Action> newactions = new LinkedList<>(getActions());
+		newactions.add(action);
+		return new SAOPState(newactions, getConnections(), advanceProgress(),
+				getSettings(), getPartyProfiles(), null);
+	}
+
+	/**
 	 * Check up to nparticipants-1 steps back if there was an offer.
 	 * 
@@ -182,54 +217,4 @@
 	}
 
-	private SAOPState with1(PartyId actor, Action action)
-			throws ProtocolException {
-
-		if (actor == null) { // this is a bug
-			throw new IllegalArgumentException("actor must not be null");
-		}
-		if (!actor.equals(getNextActor())) {
-			throw new ProtocolException("Party does not have the turn ",
-					actor.getName());
-
-		}
-		if (action == null) {
-			throw new ProtocolException("action is null", actor.getName());
-		}
-		if (!actor.equals(action.getActor())) {
-			throw new ProtocolException(
-					"act contains wrong credentials: " + action,
-					actor.getName());
-		}
-
-		// check protocol is followed for specific actions
-		if (action instanceof Accept) {
-			Bid bid = getLastBid();
-			if (bid == null) {
-				throw new ProtocolException("Accept without a recent offer",
-						actor.getName());
-			}
-			if (!bid.equals(((Accept) action).getBid())) {
-				throw new ProtocolException(
-						"Party accepts a bid differing from the last offer ="
-								+ bid + ", action=" + action + ")",
-						actor.getName());
-			}
-		} else if (action instanceof Offer) {
-			// offer is always fine. We don't check if bid is actually in domain
-			// or complete etc. We would need domain for that
-		} else if (action instanceof EndNegotiation) {
-			// just act, we will get into the final state then.
-		} else {
-			throw new ProtocolException(
-					"Action " + action + " is not allowed in SAOP",
-					actor.getName());
-		}
-
-		List<Action> newactions = new LinkedList<>(getActions());
-		newactions.add(action);
-		return new SAOPState(newactions, getConnections(), advanceProgress(),
-				getSettings(), getPartyProfiles(), null);
-	}
-
 	/**
 	 * 
Index: /protocol/src/main/java/geniusweb/protocol/session/saop/SaopPartyWithProfile.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/saop/SaopPartyWithProfile.java	(revision 10)
+++ /protocol/src/main/java/geniusweb/protocol/session/saop/SaopPartyWithProfile.java	(revision 10)
@@ -0,0 +1,29 @@
+package geniusweb.protocol.session.saop;
+
+import java.util.Arrays;
+import java.util.List;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.protocol.session.TeamOfPartiesAndProfiles;
+import geniusweb.references.PartyWithParameters;
+import geniusweb.references.PartyWithProfile;
+import geniusweb.references.ProfileRef;
+
+public class SaopPartyWithProfile extends PartyWithProfile
+		implements TeamOfPartiesAndProfiles {
+
+	@JsonCreator
+	public SaopPartyWithProfile(
+			@JsonProperty("party") PartyWithParameters party,
+			@JsonProperty("profile") ProfileRef profile) {
+		super(party, profile);
+	}
+
+	@Override
+	public List<PartyWithProfile> getAllParties() {
+		return Arrays.asList(this);
+	}
+
+}
Index: /protocol/src/main/java/geniusweb/protocol/session/shaop/BareSHAOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/shaop/BareSHAOPState.java	(revision 10)
+++ /protocol/src/main/java/geniusweb/protocol/session/shaop/BareSHAOPState.java	(revision 10)
@@ -0,0 +1,167 @@
+package geniusweb.protocol.session.shaop;
+
+import java.util.Collections;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.PartyId;
+import geniusweb.progress.Progress;
+import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
+import geniusweb.protocol.session.SessionSettings;
+import geniusweb.protocol.session.SessionState;
+import geniusweb.references.PartyWithProfile;
+
+/**
+ * The state without all the "with" functioality to make this more readable.
+ * immutable. json-serializable.
+ */
+public abstract class BareSHAOPState implements SessionState {
+	protected final List<Action> actions;
+
+	protected final transient ProtocolToPartyConnections connections;
+
+	protected final Progress progress;
+
+	protected final SHAOPSettings settings;
+
+	protected final ProtocolException error;
+
+	protected final int actorNr;
+
+	protected final Map<PartyId, Integer> partyNumbers;
+
+	protected final Map<PartyId, Double> totalSpent;
+
+	/**
+	 * 
+	 * @param actions    value for actions done so far. null equals to empty
+	 *                   list
+	 * @param conns      the currently existing connections. Can be empty/null.
+	 *                   Each connection represents another party. Normally
+	 *                   there is exactly 1 connection for every party. The
+	 *                   protocol should check this.
+	 * @param progr      the {@link Progress} that governs this session. Can be
+	 *                   null if session did not yet start.
+	 * @param settings   the settings used for the session
+	 * @param e          the exception that occured, usually null. All errors
+	 *                   occuring due to faulty {@link Action}s translate to
+	 *                   {@link ProtocolException}s. All errors in our own code
+	 *                   are bugs (not ProtocolExceptions) and should result in
+	 *                   a throw.
+	 * @param actorNr    the actor that has the turn, index {@link #connections}
+	 * @param partyNrs   a map for each known PartyId to a number. The number is
+	 *                   the index in both {@link SHAOPSettings#getTeams()} and
+	 *                   in {@link #connections}. null is empyt map.
+	 * @param totalSpent total accumulated elicitation costs so far. only SHAOP
+	 *                   parties accumulate costs. null = empty map
+	 */
+	@JsonCreator
+	public BareSHAOPState(List<Action> actions,
+			ProtocolToPartyConnections conns, Progress progr,
+			SHAOPSettings settings, ProtocolException e, int actorNr,
+			Map<PartyId, Integer> partyNrs, Map<PartyId, Double> spent) {
+		if (conns == null) {
+			this.connections = new ProtocolToPartyConnections(
+					Collections.emptyList());
+		} else {
+			this.connections = conns;
+		}
+		if (actions == null) {
+			this.actions = new LinkedList<>();
+		} else {
+			this.actions = actions;
+		}
+		if (partyNrs == null) {
+			this.partyNumbers = Collections.emptyMap();
+		} else {
+			this.partyNumbers = partyNrs;
+		}
+		if (spent == null) {
+			this.totalSpent = Collections.emptyMap();
+		} else {
+			this.totalSpent = spent;
+		}
+
+		if (!connections.allunique()) {
+			throw new IllegalArgumentException(
+					"There can not be multiple connections for a party:"
+							+ conns);
+		}
+
+		this.progress = progr;
+		this.settings = settings;
+		this.error = e;
+		this.actorNr = actorNr;
+	}
+
+	public ProtocolToPartyConnections getConnections() {
+		return connections;
+	}
+
+	/**
+	 * 
+	 * @return party ID of current actorNr
+	 */
+	public PartyId getCurrentActor() {
+		return connections.get(actorNr).getParty();
+	}
+
+	/**
+	 * @param id the {@link PartyId}
+	 * @return the PartyWithProfile associated with that id.
+	 */
+	public PartyWithProfile getPartyProfile(PartyId id) {
+		return settings.getAllParties().get(partyNumbers.get(id));
+	}
+
+	/**
+	 * 
+	 * @return the index of each party
+	 */
+	public Map<PartyId, Integer> getPartyNumbers() {
+		return Collections.unmodifiableMap(partyNumbers);
+	}
+
+	/**
+	 * 
+	 * @return unmodifyable list of actions done so far.
+	 */
+	@Override
+	public List<Action> getActions() {
+		return Collections.unmodifiableList(actions);
+	}
+
+	@Override
+	public Progress getProgress() {
+		return progress;
+	}
+
+	@Override
+	public SessionSettings getSettings() {
+		return settings;
+	}
+
+	@Override
+	public boolean isFinal(long currentTimeMs) {
+		return error != null
+				|| (progress != null && progress.isPastDeadline(currentTimeMs));
+	}
+
+	@Override
+	public ProtocolException getError() {
+		return error;
+	}
+
+	@Override
+	public String toString() {
+		return this.getClass().getSimpleName() + "[" + actions + ","
+				+ connections + "," + progress + "," + settings + "," + error
+				+ "]";
+	}
+
+}
